﻿Public Class SortedArrayList(Of T As IComparable)
    Inherits ArrayList(Of T)

    Public Function BinarySearch(item As T) As Integer
        Dim lower As Integer = 0
        Dim upper As Integer = Count - 1

        While lower <= upper
            Dim mid As Integer = (lower + upper) / 2
            ' alternativ: >> 1 anstatt / 2
            Dim o As Integer = item.CompareTo(Me(mid))

            If o = 0 Then
                Return mid
            ElseIf o > 0 Then
                lower = mid + 1 ' oben weitersuchen
            Else
                upper = mid - 1 ' unten weitersuchen
            End If
        End While
        Return Not lower
    End Function

    Public Function BinarySearchRecursive(item As T) As Integer
        Return search(item, 0, Count - 1)
    End Function

    Private Function search(item As T, lower As Integer, upper As Integer) As Integer
        If lower > upper Then
            Return Not lower
        End If

        Dim mid As Integer = (lower + upper) / 2

        Dim o As Integer = item.CompareTo(Me(mid))

        If o = 0 Then
            Return mid
        ElseIf o > 0 Then
            Return search(item, mid + 1, upper) ' oben weitersuchen
        Else
            Return search(item, lower, mid - 1) ' unten weitersuchen
        End If
    End Function
End Class