﻿Imports System.IO
Imports CompanySearch

Public Class Companies
    Private companies As New BinaryTree(Of Company)()

    Public Sub New(r As TextReader)
        ' Spaltenüberschriften auslesen
        Dim tokens = r.ReadLine().Split(New Char() {";"c})
        If tokens.Length <> 3 Then
            Throw New ArgumentException("More than 3 columns")
        End If

        Dim line As String = r.ReadLine()
        While line IsNot Nothing
            tokens = line.Split(New Char() {";"c})

            companies.Add(New Company() With {
                 .Bezeichnung = tokens(0),
                 .Branche = tokens(1),
                 .Ort = tokens(2)
            })
            line = r.ReadLine()
        End While
        r.Close()
    End Sub

    Public Function Read(bezeichnung As String) As Company
        Return companies.Search(New Company() With {
            .Bezeichnung = bezeichnung
        })
    End Function

End Class

Public Class Company
    Implements IComparable(Of Company)

    Public Property Bezeichnung As String
    Public Property Branche As String
    Public Property Ort As String

    Public Overrides Function ToString() As String
        Return String.Format("Bezeichnung: {0}" & vbTab & "Branche: {1}" & vbTab & "Ort: {2}", Bezeichnung, Branche, Ort)
    End Function

    Private Function CompareTo(other As Company) As Integer Implements IComparable(Of Company).CompareTo
        Return Bezeichnung.CompareTo(other.Bezeichnung)
    End Function
End Class
