﻿Public Class Queue(Of T)
    Implements ICollection
    Private items As T()

    Public ReadOnly Property Count() As Integer Implements ICollection.Count
        Get
            Return m_Count
        End Get
    End Property
    Private m_Count As Integer

    Public Sub New(Optional length As Integer = 0)
        items = New T(If(length = 0, 10, length) - 1) {}
    End Sub

    Public Sub Enqueue(item As T)
        grow()

        items(Count) = item

        m_Count += 1
    End Sub

    Public Function Peek() As T
        If Count = 0 Then
            Throw New InvalidOperationException("No items.")
        End If

        Return items(0)
    End Function

    Public Function Dequeue() As T
        If Count = 0 Then
            Throw New InvalidOperationException("No items.")
        End If

        Dim item As T = items(0)

        Array.Copy(items, 1, items, 0, Count - 1)

        items(Count - 1) = Nothing

        m_Count -= 1

        Return item
    End Function

    Public Sub Clear() Implements ICollection.Clear
        items = New T(10) {}
        m_Count = 0
    End Sub

    Private Sub grow()
        ' Überprüfen, ob noch Platz
        If items.Length >= Count + 1 Then
            Return
        End If

        ' Array-Kapazität verdoppeln
        Dim newLength As Integer = items.Length * 2

        Array.Resize(items, newLength)
    End Sub

End Class

