﻿Imports Queue

Public Class QueueCircularBuffer(Of T)
    Implements ICollection
    Private items As T()
    Private first As Integer = 0, last As Integer = 0

    Public ReadOnly Property Count() As Integer Implements ICollection.Count
        Get
            Return m_Count
        End Get
    End Property
    Private m_Count As Integer

    Public Sub New(Optional length As Integer = 0)
        items = New T(If(length = 0, 10, length) - 1) {}
    End Sub

    Public Sub Enqueue(item As T)
        If Count = items.Length Then
            Throw New ArgumentOutOfRangeException("No more space.")
        End If

        items(last) = item

        last += 1
        m_Count += 1
        last = last Mod items.Length    ' Umlaufprüfung

    End Sub

    Public Function Peek() As T
        If Count = 0 Then
            Throw New InvalidOperationException("No items.")
        End If

        Return items(first)
    End Function

    Public Function Dequeue() As T
        If Count = 0 Then
            Throw New InvalidOperationException("No items.")
        End If

        Dim item As T = items(first)

        items(first) = Nothing

        first += 1
        m_Count -= 1
        first = first Mod items.Length  ' Umlaufprüfung

        Return item
    End Function

    Public Sub Clear() Implements ICollection.Clear
        items = New T(10) {}
        m_Count = 0
    End Sub
End Class
